<?php

namespace app\models\mikrotik\queues;

use yii\base\Model;
use Yii;

require_once 'PEAR2_Net_RouterOS-1.0.0b5.phar';

use PEAR2\Net\RouterOS;
use app\models\mikrotik\MikrotikConnect;

class Types extends Model {

    public $id;
    public $name;
    public $kind;
    public $pfifo_limit;
    public $default;

    public function rules() {
        return [
            ['id', 'string'],
            ['name', 'string'],
            ['kind', 'string'],
            ['pfifo_limit', 'string'],
            ['default', 'string'],
        ];
    }

    public function getAll() {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/queue/type/getall');
        $responses = $connect->getConnection()->sendSync($getRequest);
        $return = array();
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $c = new Types();
                $c->id = $response->getProperty('.id');
                $c->name = $response->getProperty('name');
                $c->kind = $response->getProperty('kind');
                $c->pfifo_limit = $response->getProperty('pfifo-limit');
                $c->default = $response->getProperty('default');
                $return[] = $c;
            }
        }
        return $return;
    }

    public function get($id) {
        $connect = MikrotikConnect::Instance();
        $getRequest = new RouterOS\Request('/queue/type/print');
        $getRequest->setQuery(RouterOS\Query::where('.id', $id));
        $responses = $connect->getConnection()->sendSync($getRequest);
        foreach ($responses as $response) {
            if ($response->getProperty('.id') != null) {
                $this->id = $response->getProperty('.id');
                $this->name = $response->getProperty('name');
                $this->kind = $response->getProperty('kind');
                $this->pfifo_limit = $response->getProperty('pfifo-limit');
                $this->default = (($response->getProperty('default') == 'true') ? true : false);
            }
        }
        return;
    }

    public function update($id) {
        $c = new Types();
        $c->get($id);
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/queue/type/set');
        $setRequest->setargument('.id', $id);
        if ($this->name != $c->name) {
            $setRequest->setargument('name', $this->name);
        }
        if ($this->kind != $c->kind) {
            $setRequest->setargument('kind', $this->kind);
        }
        if ($this->pfifo_limit != $c->pfifo_limit) {
            $setRequest->setargument('pfifo-limit', $this->pfifo_limit);
        }
        if (isset($unset)) {
            $unsetRequest = new RouterOS\Request('/queue/type/unset');
            foreach ($unset as $value) {
                $unsetRequest->setArgument('.id', $id);
                $unsetRequest->setArgument('value-name', $value);
                $resp = $connect->getConnection()->sendSync($unsetRequest);
                if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
                    if (!isset($re)) {
                        $re = '';
                    } $re.= ' ' . $resp->getProperty('message');
                }
            }
        } $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            if (isset($re)) {
                $re.= ' ' . $resp->getProperty('message');
            } else {
                $re = $resp->getProperty('message');
            }
        } if (isset($re)) {
            return $re;
        } else {
            return '1';
        }
    }

    public function disable($id) {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/queue/type/disable');
        $setRequest->setArgument('.id', $id);
        $connect->getConnection()->sendSync($setRequest);
        return;
    }

    public function enable($id) {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/queue/type/enable');
        $setRequest->setArgument('.id', $id);
        $connect->getConnection()->sendSync($setRequest);
        return;
    }

    public function create() {
        $connect = MikrotikConnect::Instance();
        $setRequest = new RouterOS\Request('/queue/type/add');
        if ($this->name != "") {
            $setRequest->setargument('name', $this->name);
        }
        if ($this->kind != "") {
            $setRequest->setargument('kind', $this->kind);
        }
        if ($this->pfifo_limit != "") {
            $setRequest->setargument('pfifo-limit', $this->pfifo_limit);
        }
        $resp = $connect->getConnection()->sendSync($setRequest);
        if ($resp->getType() !== RouterOS\Response::TYPE_FINAL) {
            return $resp->getProperty('message');
        } else {
            return '1';
        }
    }

    public function delete($id) {
        $connect = MikrotikConnect::Instance();
        $util = new RouterOS\Util($connect->getConnection());
        $util->setMenu('/queue/type');
        $util->remove(RouterOS\Query::where('.id', $id));
        return;
    }

}
